/*
********************************************************************************
* COPYRIGHT(c)    ϻ, 2019
* 
*        (as is).
*     .
********************************************************************************
*/


#ifndef __USBKEYS_H
#define __USBKEYS_H

#include "board.h"


//
#define   KEYS_SCAN_TIMER                  TIM16
#define   KEYS_SCAN_TIMER_ENR              APB2ENR
#define   KEYS_SCAN_TIMER_CLK_EN           RCC_APB2ENR_TIM16EN
#define   KEYS_SCAN_TIMER_PSC              3199
#define   KEYS_SCAN_TIMER_ARR              1499
#define   KEYS_SCAN_TIMER_IRQ              TIM16_IRQn


#define   KEYS_SCAN_PRIORITY               2


typedef struct
{
  uint16_t PinBit;
  uint8_t  Code;
  uint8_t  State;  
  
} KeyType;


enum KeyState
{
  KEY_RELEASED = 0,
  KEY_PRESSED = 1,
};

enum KeyDataState
{
  KEY_DATA_NOT_CHANGED = 0,
  KEY_DATA_CHANGED = 1,
};



void USBKeys_Init();

void KEYS_SCAN_TIMER_ISR(void);



#endif //__USBKEYS_H