/*
********************************************************************************
* COPYRIGHT(c)    ϻ, 2019
* 
*        (as is).
*     .
********************************************************************************
*/



#ifndef __USBD_AUDIO_HID_H
#define __USBD_AUDIO_HID_H


#include "usbd_audio_core.h"
#include "usbd_custom_hid_core.h"


#define       HID_INTERFACE                   0x2
#define       USB_AUDIO_HID_CONFIG_DESC_SIZ   (AUDIO_CONFIG_DESC_SIZE + CUSTOMHID_SIZ_CONFIG_DESC + 8)



extern USBD_Class_cb_TypeDef  USBD_AUDIO_HID_cb;


uint8_t USBD_AUDIO_HID_Init(void  *pdev, uint8_t cfgidx);

uint8_t USBD_AUDIO_HID_DeInit(void  *pdev, uint8_t cfgidx);

uint8_t USBD_AUDIO_HID_Setup(void  *pdev, USB_SETUP_REQ *req);

uint8_t *USBD_AUDIO_HID_GetConfigDescriptor(uint8_t speed, uint16_t *length);

uint8_t USBD_AUDIO_HID_DataIn(void  *pdev, uint8_t epnum);

uint8_t USBD_AUDIO_HID_DataOut(void *pdev , uint8_t epnum);

uint8_t USBD_AUDIO_HID_SOF(void *pdev);

uint8_t USBD_AUDIO_HID_EP0_RxReady(void *pdev);



#endif //__USBD_AUDIO_HID_H
