/*
********************************************************************************
* COPYRIGHT(c)    ϻ, 2019
* 
*        (as is).
*     .
********************************************************************************
*/



#include "I2S.h"
#include "usbd_audio_core.h"


void I2S_Init()
{
  I2S_GPIO->OSPEEDR |= (3 << (2 * I2S_WS_PIN)) | (3 << (2 * I2S_CK_PIN)) \
                    | (3 << (2 * I2S_MCK_PIN)) | (3 << (2 * I2S_SD_PIN));
  
  I2S_GPIO->MODER |= (2 << (2 * I2S_WS_PIN)) | (2 << (2 * I2S_CK_PIN)) \
                  | (2 << (2 * I2S_MCK_PIN)) | (2 << (2 * I2S_SD_PIN));
  
  RCC->APB2ENR |= RCC_APB2ENR_SPI1EN;
  I2S_PORT->I2SPR = 0x04;
  I2S_PORT->I2SCFGR = SPI_I2SCFGR_I2SMOD | SPI_I2SCFGR_I2SCFG_1 | \
                      SPI_I2SCFGR_DATLEN_1 | SPI_I2SCFGR_CHLEN;
  
  RCC->AHBENR |= RCC_AHBENR_DMAEN;    
  I2S_DMA_CHANNEL->CCR = DMA_CCR_CIRC | DMA_CCR_HTIE | DMA_CCR_TCIE | DMA_CCR_DIR | DMA_CCR_MINC | DMA_CCR_PSIZE_0 | DMA_CCR_MSIZE_0 | DMA_CCR_PL;
  I2S_DMA_CHANNEL->CPAR = (uint32_t) (&(I2S_PORT->DR));
  
  
  //Timer I2S MCKL
  MCLK_GPIO->MODER |= (2 << (2 * MCLK_PIN));
  MCLK_GPIO->AFR[0] |= (MCLK_TIMER_AF << (4 * MCLK_PIN));
  RCC->MCLK_TIMER_ENR |= MCLK_TIMER_CLK_EN;  
  MCLK_TIMER->CCMR1 = TIM_CCMR1_OC1M_2 | TIM_CCMR1_OC1M_1 | TIM_CCMR1_OC1PE;
  MCLK_TIMER->BDTR = TIM_BDTR_MOE;
  MCLK_TIMER->CCER = TIM_CCER_CC1E;
  MCLK_TIMER->PSC = 0;
  MCLK_TIMER->ARR = 1;
  MCLK_TIMER->CCR1 = 1;
}
//------------------------------------------------------------------------------
void I2S_Stop()
{
  I2S_DMA_CHANNEL->CCR &= ~DMA_CCR_EN;
  DMA1->IFCR |= DMA_IFCR_CGIF3;
  MCLK_TIMER->CR1 &= ~TIM_CR1_CEN;
  I2S_PORT->I2SCFGR &= ~SPI_I2SCFGR_I2SE;
  I2S_PORT->CR2 = 0;
}
//------------------------------------------------------------------------------
void I2S_Start()
{
  MCLK_TIMER->CR1 |= TIM_CR1_CEN;
  I2S_DMA_CHANNEL->CCR |= DMA_CCR_EN;
  I2S_PORT->CR2 = SPI_CR2_TXDMAEN;
  I2S_PORT->I2SCFGR |= SPI_I2SCFGR_I2SE;
}


