/*
********************************************************************************
* COPYRIGHT(c)    ϻ, 2019
* 
*        (as is).
*     .
********************************************************************************
*/



#include "USBKeys.h"
#include "usbd_custom_hid_core.h"


KeyType Keys[KEYS_COUNT];
USB_CORE_HANDLE  USB_Device_dev;
uint8_t PrevXferDone = 1;


void USBKeys_Init()
{
  Keys[0].PinBit = 1 << KEY_0_PIN;
  Keys[1].PinBit = 1 << KEY_1_PIN;
  Keys[2].PinBit = 1 << KEY_2_PIN;
  Keys[3].PinBit = 1 << KEY_3_PIN;
  Keys[4].PinBit = 1 << KEY_4_PIN;
  
  for(uint8_t i = 0; i < KEYS_COUNT; i++)
  {
    Keys[i].Code = 1 << i; //    CustomHID_ReportDescriptor
    Keys[i].State = 0;    
  }
  
  RCC->KEYS_SCAN_TIMER_ENR |= KEYS_SCAN_TIMER_CLK_EN;
  KEYS_SCAN_TIMER->PSC = KEYS_SCAN_TIMER_PSC;
  KEYS_SCAN_TIMER->ARR = KEYS_SCAN_TIMER_ARR;
  KEYS_SCAN_TIMER->DIER = TIM_DIER_UIE;
  NVIC_EnableIRQ(KEYS_SCAN_TIMER_IRQ);
  NVIC_SetPriority(KEYS_SCAN_TIMER_IRQ, KEYS_SCAN_PRIORITY);
  
  KEYS_SCAN_TIMER->CR1 |= TIM_CR1_CEN;
}
//------------------------------------------------------------------------------
void KEYS_SCAN_TIMER_ISR(void)
{
  KEYS_SCAN_TIMER->SR &= ~TIM_SR_UIF;
  
  uint8_t KeysData[] = { HID_REPORT_ID, 0x00, };
  uint8_t KeysDataFlag = KEY_DATA_NOT_CHANGED;
  
  for(uint8_t i = 0; i < KEYS_COUNT; i++)
  {
    if ((KEYS_GPIO->IDR & Keys[i].PinBit) != Keys[i].PinBit)
    {
      KeysData[1] |= Keys[i].Code;
      Keys[i].State = KEY_PRESSED;
      KeysDataFlag = KEY_DATA_CHANGED;
    }
    
    else if (Keys[i].State == KEY_PRESSED)
    {
      Keys[i].State = KEY_RELEASED;
      KeysDataFlag = KEY_DATA_CHANGED;
    }
  }
  
  if (KeysDataFlag == KEY_DATA_CHANGED)
  {
    if ((PrevXferDone) && (USB_Device_dev.dev.device_status == USB_CONFIGURED))
    {    
      USBD_HID_SendReport(&USB_Device_dev, KeysData, HID_IN_PACKET);
      PrevXferDone = 0;
    } 
  }
}



